<template>
  <q-modal
    :value="!!column"
    @hide="close"
  >
    <div class="q-pa-md" v-if="column">
      <div class="q-title">Edit <b>{{ column.label }}</b> column configuration</div>

      <div
        class="q-mt-md"
      >
        <component
          :is="editorComponent"
          :column="column"
        />
      </div>
    </div>
  </q-modal>
</template>

<script>
  import textColumn from './editors/textColumn';
  import numberColumn from './editors/numberColumn';
  import booleanColumn from './editors/booleanColumn';
  import datetimeColumn from './editors/datetimeColumn';
  import jsonColumn from './editors/jsonColumn';
  import urlColumn from './editors/urlColumn';
  import preColumn from './editors/preColumn';

  export default {
    name: 'collectionColumnEditor',
    props: {
      column: {
        type: Object,
      },
    },
    computed: {
      type() {
        return this.column.type;
      },
      editorComponent() {
        return ({
          text: textColumn,
          number: numberColumn,
          boolean: booleanColumn,
          datetime: datetimeColumn,
          json: jsonColumn,
          pre: preColumn,
          url: urlColumn,
        }[this.type]) || null;
      },
    },
    methods: {
      close() {
        this.$emit('close');
      },
    },
  };
</script>
